# -*- coding: utf-8 -*-
"""
Created on Tue Jan 13 15:02:47 2015

Pulls individual mpa network files into a single file.

@author: af26
"""

import glob
import networkx as NX
import os as os


for year in range(1965,2005):
    
    print year

    root_folder = ('E:/af26/LarvalDispersalResults/' +
                'polcoms'+str(year)+'/Run_1000_baseline/')
    
    path = (root_folder + 'Networkdata/*.graphml')
    files = glob.glob(path)
    
    G = NX.DiGraph()
    
    for filename in files:
        print filename
        infile = open(filename, 'r')
        H = NX.read_graphml(infile)
        infile.close()
        G = NX.compose(G, H)
        
    out_file_graphml = (root_folder + 'Networkdata/GraphCompose/' +
                   'graph_compose.graphml')
    out_file_gexf = (root_folder + 'Networkdata/GraphCompose/' +
                   'graph_compose.gexf')
    
    if not os.path.exists(os.path.dirname(out_file_graphml)):
        os.makedirs(os.path.dirname(out_file_graphml))
    with open(out_file_graphml, "w") as f:
        NX.write_graphml(G,f)
    
    with open(out_file_gexf, "w") as f:
        NX.write_gexf(G,f)
