# -*- coding: utf-8 -*-
"""
Created on Tue Jan 13 15:02:47 2015

@author: af26
"""

import networkx as NX
import matplotlib.pyplot as plt
from mpa_name_abbr_dict import MPA_name_abbr_dict
import numpy as np
import matplotlib as matplotlib

matplotlib.rcParams['font.sans-serif'] = 'Arial'


def get_betweenness(H):
    betweenness = {}        
    
    betweenness = NX.betweenness_centrality(H)
    
    mpas = []
    between = []
    for key,value in betweenness.iteritems():
        mpas.append(name_dict[key])
        between.append(value)
        
    return betweenness,between,mpas

def get_sorted_betweenness(H):
    betweenness = {}        
    
    betweenness = NX.betweenness_centrality(H)
    
# read in MPAs in sorted order

    infile = open('E:/af26/MPAlists/MPA_names_lophelia_sorted.txt','r')
    sorted_mpas = infile.readlines()
    infile.close()
    
    # strip out line breaks
    for i in range(len(sorted_mpas)):
        sorted_mpas[i] = sorted_mpas[i][0:-1]
        
    mpas = []
    between = []
    for mpa in sorted_mpas:
        mpas.append(name_dict[mpa])
        between.append(betweenness[mpa])
        
    return betweenness,between,mpas

def get_reachability(H):
    betweenness = {}        
    
    for node in NX.nodes(H):
        descendants = NX.descendants(H,node)
        betweenness[node] = len(descendants)
    
    mpas = []
    between = []
    for key,value in betweenness.iteritems():
        mpas.append(name_dict[key])
        between.append(value)

    return betweenness,between,mpas
    
def get_sorted_reachability(H):
    betweenness = {}        
    
    for node in NX.nodes(H):
        descendants = NX.descendants(H,node)
        betweenness[node] = len(descendants)

# read in MPAs in sorted order

    infile = open('E:/af26/MPAlists/MPA_names_lophelia_sorted.txt','r')
    sorted_mpas = infile.readlines()
    infile.close()
    
    # strip out line breaks
    for i in range(len(sorted_mpas)):
        sorted_mpas[i] = sorted_mpas[i][0:-1]
        
    mpas = []
    between = []
    for mpa in sorted_mpas:
        mpas.append(name_dict[mpa])
        between.append(betweenness[mpa])
        
    return betweenness,between,mpas
    
name_dict = MPA_name_abbr_dict()

graph_filter = True

run_names = ('baseline','doublelife')

icount = 0

fig, axarr = plt.subplots(2,2,figsize = (4.49,2.83),sharex='col',sharey='row')


for run_name in run_names:
        
    root_folder = ('E:/af26/LarvalDispersalResults/' +
                'polcoms1965to2005/'+run_name+'/')
    
    filename = (root_folder + 
                'graph_compose_latlon_lophelia.graphml')
    
    infile = open(filename, 'r')
    H1 = NX.read_graphml(infile)
    infile.close()
    
    filename = (root_folder + 
                'graph_compose_naohigh_latlon_lophelia.graphml')
    
    infile = open(filename, 'r')
    H2 = NX.read_graphml(infile)
    infile.close()
    
    filename = (root_folder + 
                'graph_compose_naolow_latlon_lophelia.graphml')
    
    infile = open(filename, 'r')
    H3 = NX.read_graphml(infile)
    infile.close()
    
# reachability

    betweenness1, between1, mpas1 = get_sorted_reachability(H1)
    betweenness2, between2, mpas2 = get_sorted_reachability(H2)
    betweenness3, between3, mpas3 = get_sorted_reachability(H3)
    
    # 3 bars on single plot
            
    index = np.arange(len(betweenness1))
    bar_width = 0.25
    
    j = icount//2
    i = icount%2
        
    bar1 = axarr[i,j].bar(index, between1, bar_width, color='r',linewidth = 0.3)
    bar2 = axarr[i,j].bar(index + bar_width, between2, bar_width, color='y',linewidth = 0.3)
    bar3 = axarr[i,j].bar(index + 2.0 * bar_width , between3, bar_width, color='g',linewidth = 0.3)
    
    axarr[i,j].tick_params(length = 1.0)
    axarr[i,j].set_xticks(index + 1.5 * bar_width)
    axarr[i,j].set_xticklabels(mpas1, rotation = 90,fontsize=6)
    if j == 0:
        axarr[i,j].set_ylabel('descendants', fontsize=6)
    axarr[i,j].set_ylim([0, 13])
    axarr[i,j].set_yticklabels(np.array(range(7))*2,fontsize=6)
    for axis in ['top','bottom','left','right']:
        axarr[i,j].spines[axis].set_linewidth(0.5)
    
#    plt.xticks(index + 1.5 * bar_width, mpas1, rotation = 90)
    
#    axarr[i,j].legend((bar1[0], bar2[0], bar3[0]), 
#              ('all years', 'high NAO index', 'low NAO index'), ncol = 3,prop={'size':6})

    icount = icount + 1

# betweenness


    betweenness1, between1, mpas1 = get_sorted_betweenness(H1)
    betweenness2, between2, mpas2 = get_sorted_betweenness(H2)
    betweenness3, between3, mpas3 = get_sorted_betweenness(H3)


    index = np.arange(len(betweenness1))
    bar_width = 0.25
        
    j = icount//2
    i = icount%2
    
    bar1 = axarr[i,j].bar(index, between1, bar_width, color='r',linewidth = 0.3)
    bar2 = axarr[i,j].bar(index + bar_width, between2, bar_width, color='y',linewidth = 0.3)
    bar3 = axarr[i,j].bar(index + 2.0 * bar_width , between3, bar_width, color='g',linewidth = 0.3)
    
    axarr[i,j].tick_params(length = 1.0)
    axarr[i,j].set_xticks(index + 1.5 * bar_width)
    axarr[i,j].set_xticklabels(mpas1, rotation = 90,fontsize=6)
    if j == 0:
        axarr[i,j].set_ylabel('betweenness',fontsize = 6)
    axarr[i,j].set_ylim([0, 0.3])
    axarr[i,j].set_yticklabels(np.array(range(7))*0.05,fontsize=6)
    for axis in ['top','bottom','left','right']:
        axarr[i,j].spines[axis].set_linewidth(0.5)
    
#    plt.xticks(index + 1.5 * bar_width, mpas1, rotation = 90)
    
#    axarr[i,j].legend((bar1[0], bar2[0], bar3[0]), 
#              ('all years', 'high NAO index', 'low NAO index'),prop={'size':6})

    icount = icount + 1

axarr[0,0].text(0.2, 11.5,'a', fontsize = 10)
axarr[0,1].text(0.2, 11.5,'b', fontsize = 10)
axarr[0,0].text(3, 13.5,'standard', fontsize = 10)
axarr[0,1].text(3, 13.5,'long-lived', fontsize = 10)
axarr[1,0].text(0.2, 0.25,'c', fontsize = 10)
axarr[1,1].text(0.2, 0.25,'d', fontsize = 10)

plt.subplots_adjust(left=0.09, bottom=0.17, right=0.99, top=0.95, 
                    wspace=0.07, hspace=0.1)        
axarr[1,0].legend((bar1[0], bar2[0], bar3[0]), 
        ('40 years', '10 years most +ve March NAO', '10 years most -ve March NAO '),
        bbox_to_anchor=(0., -0.4, 2.0, .102),
        mode = "expand",
        ncol = 3,
        frameon=False,
        prop={'size':6})
              
#plt.tight_layout(pad=1)

plt.show()

filenameroot = ('C:/Users/af26/Documents/Papers/LopheliaConnectivity/' + 
                 'reach_between_all')    
plt.savefig(filenameroot + '.png', dpi = 1000)  
plt.savefig(filenameroot + '.pdf')  
plt.savefig(filenameroot + '.svg')  
plt.savefig(filenameroot + '.eps', format='eps', dpi=1200)
